package com.itbaizhan.mapper;

import com.itbaizhan.pojo.User;
import com.itbaizhan.pojo.PageQuery;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface UserMapper {
    List<User> findAll();


    void add(User user);

    void update(User user);

    void delete(int id);

    User findById(int id);


    /**
     * 模糊查询
     * @param username
     * @return
     */
    List<User> findByUsernameLike(String username);

    /**
     * 分页查询
     * @param startIndex 开始索引
     * @param pageSize   每页条数
     * @return
     */
    List<User> findPage1(@Param("startIndex") int startIndex,@Param("pageSize") int pageSize);

    List<User> findPage2(PageQuery pageQuery);

    List<User> findPage3(Map params);


    //查询用户总数
    int findCount();

    void add2(User user);

    List<User> findByCondition(User user);

    void updateUser(User user);

    /***
     * 用户名<5时使用模糊查询，
     * 用户名>=5并且<10时使用精确查询，
     * 否则查询id为1的用户
     */

    List<User> findByUsername(String username);

    //批量删除
    void deleteBatch(int[] ids);

    //批量添加
    void insertBatch(List<User> user);

    /**
     * 多条件查询
     * @param map 查询的条件键值对  键：属性名   值：属性值
     *              select * from user where username = ? and sex = ?
     * @return
     */
    List<User> findUser(@Param("queryMap") Map<String,Object> map);

}


