import com.itbaizhan.mapper.TeacherMapper;
import com.itbaizhan.mapper.UserMapper;
import com.itbaizhan.pojo.PageQuery;
import com.itbaizhan.pojo.Teacher;
import com.itbaizhan.pojo.User;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/***
 * 利用Junit前置后置方法  优化测试类代码
 *
 * 执行test方法前都需要执行before   执行test方法后都需要执行after
 */
public class TestTeacherMapper {
    InputStream is = null;
    SqlSession session = null;
    TeacherMapper teacherMapper = null;
    @Before
    public void before() throws Exception {
        //读取核心配置文件
        is = Resources.getResourceAsStream("SqlMapConfig.xml");

        //创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();

        //SqlSessionFactoryBuilder对象获取sqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);

        //sqlSessionFactory对象获取SqlSession对象
        session = factory.openSession();

        //SqlSession对象获取代理对象
        teacherMapper = session.getMapper(TeacherMapper.class);
    }

    @After
    public void after() throws Exception {
        session.commit();
        session.close();
        is.close();
    }

    @Test
    public void testFindAll(){
        List<Teacher> all = teacherMapper.findAll();
        all.forEach(System.out::println);
    }

    @Test
    public void testFindById(){
        Teacher byId = teacherMapper.findById(1);
        System.out.println(byId);
    }

    @Test
    public void testFindById2(){
        List<Teacher> byId2 = teacherMapper.findById2(3);
        byId2.forEach(System.out::println);
    }

}
