
import com.itbaizhan.mapper.StudentMapper;
import com.itbaizhan.pojo.Student;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;


import java.io.InputStream;
import java.util.List;


/***
 * 利用Junit前置后置方法  优化测试类代码
 *
 * 执行test方法前都需要执行before   执行test方法后都需要执行after
 */
public class TestManyTableQuery {
    InputStream is = null;
    SqlSession session = null;

    @Before
    public void before() throws Exception {
        //读取核心配置文件
        is = Resources.getResourceAsStream("SqlMapConfig.xml");

        //创建SqlSessionFactoryBuilder对象
        SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();

        //SqlSessionFactoryBuilder对象获取sqlSessionFactory对象
        SqlSessionFactory factory = builder.build(is);

        //sqlSessionFactory对象获取SqlSession对象
        session = factory.openSession();


    }

    @After
    public void after() throws Exception {
        session.commit();
        session.close();
        is.close();
    }

    @Test
    public void testFindAll(){
        StudentMapper mapper = session.getMapper(StudentMapper.class);
        List<Student> all = mapper.findAll();
        all.forEach(System.out::println);
    }

}
